[V2.x.x.x]
	P4V. Test
[V2.5.0.0]
	1.	Add mac80211 iw utility other commands support.
		Rename crda.c to cfg80211.c, CRDA_SUPPORT to RT_CFG80211_SUPPORT.
	2.	Fix issue: No McuCmdLock initialization for RT3592/RT3390.
	3.	Fix issue: The start address of HeaderBuf must be aligned by 4 when
		VENDOR_FEATURE1_SUPPORT is enabled.
	4.	WMM ACM: see history of acm_comm.c.
	5.	Fix issue: sometimes rt2860_interrupt() will be called before rt28xx_init()
		in fedora core 7.
	6.	Add RT3592 PCIe chip ID.
	7.	Fix issue in 64bit CPU:
		(1) WMM ACM: see history of acm_comm.c.
		(2) Fix function RTMP_MapChannelID2KHZ().
	8.	CFG80211: Patch for Linux 2.6.32.
	9.  Add an ATE command for AUTOALC.
	10. Add an ATE command for interpacket GAP.
	11. Add an ATE command for ATE payload pattern.
	12. Fix issue: UAPSD SP can not be closed correctly for mix-mode power save.
		UAPSD + legacy PS.
	13. [Bug fixed] The extended rate of probe-req is disappeared in AP-Client mode	
	14. Add RT3593 PCI/PCIe AP/STA.
	15. Fix issue: kernel panic when we forward VLAN bc/mc packet to wireless LAN.
	16. Fix issue: some reports from Prevent software analysis tool.
	17. Fix issue: get wrong VLAN priority from VLAN tag in RTMPCheckEtherType().
	18. Fix issue: no 11b basic rate in beacon when we change WirelessMode to 2.4G,
		then 5G, then 2.4G
	19. Fix issue: no 11b-only mode can be set in AP mode.
	20. MBSS: add function to set different phy mode for different BSS.
	21. Phy Mode: add check if the chip supports 5G band when WirelessMode is 5G band
		for command WirelessMode and MBSSWirelessMode.
	22. QLOAD: Fix issue for big endian.
		Or value of QLOAD element in beacon will be wrong.
	23. USB: Fix timer trigger fail after APStop and then APStartup.
		Side effect1: Power save can not work in AP mode when you do channel
		switch because channel switch will do APStop() and APStart().
		Side effect2: After radion on/off, TIM will not be updated due to beacon
		timer is not started.
	24. Station: Add new rate switch algorithm (AGS) for 1*1, 2*2, 3*3.
	25. AP: Fix power save problem when station is in power-save mode and send
		(re)associate frame again we will think the station is still in PS mode,
		but the station is in ACTIVE mode.
	26. TX Block: Fix no packet can be sent when TX Fail count > a threshold for
		non-WDS interface in RTMPDeQueuePacket().
	27. Fix WPS issue: WPS process failed with some WPS Client that sends dis-assoc close to WSC_DONE. 
	28. Refine the stack size of all functions to be smaller than 300B.
	29. Fix bugs when protocol field of packet & 0x8080 does not equal to 0.
		Such as PPPOE.
	30. Fix issue: Wrong MACRO use for RTMP_SET_PACKET_DHCP ~ RTMP_SET_PACKET_IPV4.
	31.	Fix ACM issue: Need also to unlock after calling ACMP_MsduClassify() in USB.
	32.	Fix IGMP bc/mc User Priority issue: Need also to get UP for bc/mc packets.

[V2.4.0.0]
	1.	AMSDU supports NO-ACK.
	2.	Added new channel list of A-Band Region 16
	3.	Basic Ethtool support. (i.e. GSO)
	4.	Fix issue: PCI command thread initialization in pci_main_dev.c
		init_waitqueue_head(&pAd->cmdQTask.kthread_q); for KTHREAD_SUPPORT
	5.	WMM ACM: see history of acm_comm.c.
	6.	Fix issue: When PS-Poll is received in AP and STA is not WMM device and
		no any queued packet, we will reply DATA NULL frame. We will double-lock.
	7.	AP QLOAD: Add compile option.
	8.	Add CRDA function in Linux 2.6.28 above.
	9.	Increase channel property. Property is only set in CRDA function currently.
	10. RSSI feedback supported(only with Ralink client).
	11. Fix issue: Wmm capable will be enabled from ABG mode to N mode but Wmm capable is
		not recovered when from N mode to ABG mode.
	12.	Two iwpriv commands "ACLDelEntry" and "ACLShowAll" are added.
	13. Support 802.11v draft 5.0 WNM - BSS transition Management and DMS.
	14. Add OS abstract layer partition, util.ko, driver.ko, and netif.ko
	15. Support ApClient WPS PBC.

[V2.3.0.0]
	1.	WMM ACM AP/STA support. (Pass WiFi Test Plan v0.30)
	2.	Add HAS_STATS_COUNT compile option.
	3.	Provide some 802.1x parameter support(Quiet-period, idle-timeout, NAD-ID).
	4.	Fix issue : The Tx date rate can't be fixed in B/G PHY mode.
	5.	QLOAD: Add status information display function. "qload show" & QloadClr.
	6.	QLOAD: Add channel busy alarm and a command thread in PCI/USB driver.
	7.	It supports the MAC assignment from configuration file(.dat).
	8.	Fix issue : No packet is delivered from AP when PsMode from PS to ACTIVE.
	9.	Fast Power Save : Use Null frame with PM=0 to get buffered packet, not PS-Poll in station mode.
	10.	miniupnpd supported.
	11. AP-Client and WDS support fixed rate.
	12.	Support GreenAP.
	13. Support Single SKU.
	14.	Fix issue : RT3062/RT3562 can't enable/disable Radio.
	15.	Discard IgmpSn enable setting per BSSID and change it to as global setting.

[V2.2.0.0]
	1. 	New generation schema for multiple OS porting
	2. 	New chip support for RT3572
	3.	New chip support for RT3062/RT3562
	4.	Restrict the encryption type in HT mode.
	5.	Support 802.1x reauthentication mechanism.
	6.	Limit the STA connection count per BSS.
	7.	Some variables support MBSS setting.
	8.	Support WDS entry life check function.
	9.	Support Mesh Air link time.
	10.	Support Mesh Link Metric report action.
	11.	Support Dot11K RRM for all testing cases of voice-enterprise testing event.
	12.	Performance Tune.

[V2.1.1.0]
	1.  fix eFuse bug on big-endian platform
	2.  fix WMM problem for RT3071/72 
	3.  fix one bug for ATE TX power handling and ATE frequency offset bug.
	4.  fix mesh crash issue
	5.  fix RT307x AMPDU throughput bug after interface down/up
	6.  update RT307x new firmware.

[V2.1.0.0]
	1.  Support new chips RT3070/71/72, RT3090/91/92.
	2.  Fix bugs: fix WMM, Mesh, WDS, AP Client and DLS problems for Amazon SE platform
	3.  Fix bug: memory leakage problem when interface up/down.
	4.  Support eFuse.    

[V2.0.0.0]
	1.	Added Global Country Domain supported.
	2.	Fix bug: suspend/resume error when ra0 down, rax up
	3.	Add new UAPSD SP counting mechanism.
	4.	Fix bug: Ikanos WDS, AP Client, Mesh interface get problem.
	5.	Add new WSC hardware push button function for PCI & USB.
	6.	Added a function allow user to specific Tx rate for Mcast packets.
	7.	Migrate Mesh supporting to Draft-2.0.
	8.	Support WAPI functionality
	9.	Modify the priority of BAR transmission to solve the connection issue with Intel 4965 11n STA.
	10.	Fix RT2870 USB suspend/resume.

[V1.9.0.0]
	1.	Replace iwpriv cmd "AccessControlList" by "ACLAddEntry" and "ACLClearAll"
	2.	Fixed the wrong usage of AtoH().
	3.	Support new Windows ATE GUI.
	4.	Add a command "iwpriv ra0 set ATERE2P=1" to display all EEPROM content. 
	5.  Correct the limitation of the length of fragment.
	6.	Fix bug: Fail to transmit packets through AMPDU way except the case that AP to STA.
	7.	Wrong Hareware packet length calculation of Mesh packet if it been Fragmented.
	8.	Support SIGMA 8622/8624 platform. 
	9.	Add WPS PBC Session Overlap Detecting.
	10.	Add WPS 4-PinCode Support.
	11.	Fixed WPS enable PSP can not associate AP when AP security set to WPA-PSK.  
	12.	Fix "Suspend to Disk" problem for USB

[V1.8.0.0]
	1.	Show Tx/Rx statistics per MBSS.
	2.	802.1x supports failover mechanism.
	3.	Add watchdog to prevent MAC/BBP into the deadlock condition.
	4.	Support pure 11n with 5G band.
	5.	Update Timer Functions
	6.	In multiple cards application, the interface name is changed to raxx_k, where xx means card ID (0 ~ 31) and
		k means the BSS number (0 ~ 7)
	7.	Support individual MCS per BSS.
	8.	Add IKANOS Vx160 and Vx180.
	9.	Add station keep alive detection function in AP mode.
	10.	The SIFS of CCK is changed to 16 micro seconds to fix the connection problem with INTEL 2200bg cards.
	11.	QBSS Load Element is added to provide channel utilization information to all STAs.
	12.	Fix bug : After AP re-key, the ping connection from client to AP would be time-out within several seconds. 
	13.	Support Mesh function.
	14.	Big-endian ATE supported.
	

[V1.7.0.0]
	1.	Support IDS notification mechanism
	2.	Change IRQ LOCK to SEM LOCK
	3.	Fix bug : When QoS(non-BE) and fragment packets are received, AP would calculate wrong MIC in TKIP mode.  
	4.	Support Non-GPL MD5
	5.	Update Group rekey mechanism	
	6.	Fix BA time-out issue for Intel wireless card 4965AGN with version 11.5.0.32. 
	7.	Add command "iwpriv ra0 set ATELDE2P=1" to overwrite all EEPROM contents from "/etc/Wireless/RT2860(/70)AP(/STA)/e2p.bin".
	8.	Fix RTS threshold issue in 5G-band 
	9.	Add DLS Function.
	10.	IPV6 MLDv2 support
	11.	Fix VLAN ID >= 256 can not be used.
	12	Added PCIE MSI supporting for RT2890.
	13	Added new channel list builder that create channel list according to country-code and channel Geography(in/out door).

[V1.6.0.0]
	1.	Fix bug : Before AP shutdown, AP doesn't noify those associated STA through dis-association.
	2.	Fix bug : The Atheros wireless STA card built in MacBook can't work normally when HT mode and the encryption is WEP or TKIP.
	3.	The support region in A band synchronizes with EEPROM.
	4.	It supports to initialize current wireless MAC address from E2PROM or module parameter.
	5.	Support maximum 8 MBSS and each beacon maximum length is 512 bytes.
	6.     Support 5-GHz band ATE.
	7.	Send DisAssoc frame to timeout STA.    
	8.	Workaround for Atheros STA on AES mode.
	9.	Tx RTS/CTS when AP setup BA.
	10.	Driver sends IAPP L2 frame instread of Daemon.
	11.	Correct some timeout values of WPS. 
	12.	Fix bug : The 802.1x daemon(rt2860apd) has some problem for parsing multiple parameters in MBSS.
	13.	Fix bug : The AP site survey signal isn't correct.
	14.	Provide some 11n statistics variables.
	15.    Fix bug : RT2561 module can not be removed after RT2860 module is inserted.
	16.    Added DEO (100 ~ 140) channel list for Ganmany.
	17.    Support wds phy mode and security setting for each wds link.
	18.	Fix bug : The Atheros legacy USB STA card can't connect to our AP in WPA-TKIP.
	19.	Modify rate adaptation for fast ramp-up tuning.
	20.    Fix WPS IOT issue with Atheros externnal registrar. Need Sync the user space daemon "wscd" to version 0.1.0
	21.	Fix bug : The BlackBerry/HTC can't connect to our AP.
	22.	Correct the default values of those WMM EDCA parameters.
	23.	Fix low throughput issue in Intel certification test. 

[V1.5.0.0]
	1. Added McastPhyMode and McastMcs iwpriv commands let user to specifice the rate for Multicast packets transmition.
	2. Added two configrations of McastPhyMode and McastMcs.
	3. Re-organize the WPA state machine in order to the consistency between AP and AP-Client. 
	4. Added DFS support.
	5. Added Carrier-Sense suppport.
	6. Fixed a bug about dissection issue in profile.
    7. Fixed CountryRegion and channel map, when profile's channel have not on channel list.
	8. Fixed 802.1x Authentication problem with 1x-WEP/WPA(2)-Enterprise when WPS is enabled.
	9. Fix bug : Once the radio is off and on, the beacon frames disappear. 

[V1.4.0.0]
	1. Wireless IGMP snooping support for multimedia steaming.
	2. Access control list support
	3. Re-organize the Rx data path.
	4. AP client WPS support.
	5. Fix the Auto-selecting channel issue.
	6. Add CountryString ioctl command function.
	7. Buf fix for Atheros WPS STA can not config WPS AP when Athros JumpStart STA is external Registrar.
	8. Merge for WCN test modify to WPS functions.
	9. Patch for 11n requirement, if HT mode is set and BW is 40MHz in A-band, the supported Channel number must be the multiple of 2.
	10. Fix bug: If STA card operated with zero-config, the group rekey negotiation of WPA2(PSK)-AES always fails.
	11. Add Tx & Rx Stream functionality.
        12. Support QA user interface for ATE function.

[V1.3.0.0]
	1. add vlan tag support for each BSS
	2. add support for 32bit/64bit Linux
	3. merge in plugfest code
	4. Support Ap-Client function
	5. Add new parameter "bWiFiTest" for WPA & WMM WiFi-Test.
    6. Add the setting of Japan filter coefficients for ATE.
    7. Fix bug for channel have not update when auto channel select was true. 

[V1.2.1.0]
	1. add protect for RTMP_IRQ_LOCK to avoid in spin_lock_irqsave call spin_lock_bh cause kernel waring messages.
	2. tag one branch named V_1_2_1_0 (v1.2.1.0) in the CVS

[V1.2.0.0]
	1. set BBP R66 to 0x38 in 20 MHz band
	2. Disable one mechanism - change 40 to 20 MHz automatically when detecting other legacy APs with beacon.
	3. Fix bug for counterMeasures in WiFi test
	4. Write TXWI in ATE's way and disable any protection mechanism when ATE is running.			
	5. Asic only takes care of the sequence number of beacon frame.
	6. disable ATE RSSI statistics when ATE is not running.	   
	7. Set CW_MAX from 10 to 6 in AP mode.
	8. Select DAC according to HT or Legacy mode. 
	9. Support WPA2 Pre-authemtication.
	10. Fix WDS panic bug
	11. Shift skb control block used by driver to offset 10 to avoid dirty cb[] from protocol stack
	12. modify mac register "PBF_MAX_PCNT" from  0x1F3f7f9f to 0x1f3fbf9f
	13.	Fix issue - 802.1X daemon may cause throughput reduction.
	14. Support Wireless event log mechanism.	
	15. Add a 200ms-timer to enqueue EAPoL-Start for WPAPSK, not RtmpusecDelay.
	16. modify mac register "EXP_ACK_TIME" from 0x002400ca to 0x005400ca.
	17. Auto-selecting channel check.
     
[V1.1.0.0]
	1. Add fast rate switch from Windows code
	2. tune BBP R66, R62, R63, R64, R86 by bandwidth and G/A band different value
	3. Modify release to DPA and DPB
	4. Modify fast rate switch timer form periodic to trigger by condition, same with Windows
	5. Fix UAPSD bugs for null frame was drop
	6. Fix management queue pass qos null frame ...
	7. Code freeze for Wifi
	8. fix 5vt packet set to 0 to clear cb[22]
	9. merge code from Plugfest #6
	10. add "iwpriv ra0 show driverinfo" to show the driver version
	11. fix rt_config.h tag of Support station with tab
	12. merge ATE code request by Gemtek
	13. remove 5VT enhancement in RX path

[V1.0.0.0]
1.RT2860c emulation ping ok
